<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../general.ent">
  %general-entities;
]>

<sect1 id="ch-system-bc" role="wrap">
  <?dbhtml filename="bc.html"?>

  <sect1info condition="script">
    <productname>bc</productname>
    <productnumber>&bc-version;</productnumber>
    <address>&bc-url;</address>
  </sect1info>

  <title>Bc-&bc-version;</title>

  <indexterm zone="ch-system-bc">
    <primary sortas="a-Bc">Bc</primary>
  </indexterm>

  <sect2 role="package">
    <title/>

    <para>Bc 软件包包含一个任意精度数值处理语言。</para>

    <segmentedlist>
      <segtitle>&buildtime;</segtitle>
      <segtitle>&diskspace;</segtitle>

      <seglistitem>
        <seg>&bc-ch6-sbu;</seg>
        <seg>&bc-ch6-du;</seg>
      </seglistitem>
    </segmentedlist>

  </sect2>

  <sect2 role="installation">
    <title>安装 Bc</title>

    <para>首先修改一个内部脚本，使它使用 <command>sed</command>，
    而不是 <command>ed</command>：</para>

<screen><userinput remap="pre">cat &gt; bc/fix-libmath_h &lt;&lt; "EOF"
#! /bin/bash
sed -e '1   s/^/{"/' \
    -e     's/$/",/' \
    -e '2,$ s/^/"/'  \
    -e   '$ d'       \
    -i libmath.h

sed -e '$ s/$/0}/' \
    -i libmath.h
EOF</userinput></screen> 

    <!--para>Create temporary symbolic links so the package can find
    the readline library and confirm that its required libncurses
    library is available. Even though the libraries are in /tools/lib
    at this point, the system will use /usr/lib at the end of
    this chapter.</para-->
	<para> 创建一个临时的符号链接，使该软件包可以找到 readline 库，
		并确认它需要的 libncurses 库可用。虽然目前它还在 /tools/lib
		中，但在本章结束时系统会使用 /usr/lib 中的最后版本。 </para>

<screen><userinput remap="pre">ln -sv /tools/lib/libncursesw.so.6 /usr/lib/libncursesw.so.6
ln -sfv libncurses.so.6 /usr/lib/libncurses.so</userinput></screen>

	<para>由于LFS 早期阶段缺失了一些文件，需要修正
		<command>configure</command> 中的一个问题：</para>

<screen><userinput remap="pre">sed -i -e '/flex/s/as_fn_error/: ;; # &amp;/' configure</userinput></screen>

    <para>准备安装 Bc：</para>

<screen><userinput remap="configure">./configure --prefix=/usr           \
            --with-readline         \
            --mandir=/usr/share/man \
            --infodir=/usr/share/info</userinput></screen>

    <variablelist>
      <title>配置选项的含义：</title>

      <varlistentry>
        <term><parameter>--with-readline</parameter></term>
        <listitem>
          <!--para>This option tells Bc to use the <filename
          class="libraryfile">readline</filename> library that is already
          installed on the system rather than using its own readline
          version.</para-->
          <para>该选项告诉 Bc 使用系统中已经安装好的
			  <filename class="libraryfile">readline</filename>
			  库，而不是它自己附带的 readline 。</para>
        </listitem>
      </varlistentry>

    </variablelist>

    <para>编译该软件包：</para>

<screen><userinput remap="make">make</userinput></screen>

    <!--para>To test bc, run the commands below. There is quite a bit of output,
    so you may want to redirect it to a file. There are a very small percentage
    of tests (10 of 12,144) that will indicate a round off error at the last
    digit.</para-->
    <para>为了测试 bc，执行以下命令。它会输出很多内容，
		因此您可能希望把输出重定向到文件。
		少量测试 （12144 个测试中有 10 个）会在最后一位出现舍入误差。
	</para>

<screen><userinput remap="test">echo "quit" | ./bc/bc -l Test/checklib.b</userinput></screen>

    <para>安装该软件包：</para>

<screen><userinput remap="install">make install</userinput></screen>

  </sect2>

  <sect2 id="contents-bc" role="content">
    <title>Bc 的内容</title>

    <segmentedlist>
      <segtitle>安装的程序</segtitle>

      <seglistitem>
        <seg>bc 和 dc</seg>
      </seglistitem>
    </segmentedlist>

    <variablelist>
      <bridgehead renderas="sect3">简要描述</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <varlistentry id="bc">
        <term><command>bc</command></term>
        <listitem>
          <para>一个命令行计算器</para>
          <indexterm zone="ch-system-bc bc">
            <primary sortas="b-bc">bc</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="dc">
        <term><command>dc</command></term>
        <listitem>
          <para>一个逆波兰式命令行计算器</para>
          <indexterm zone="ch-system-bc dc">
            <primary sortas="b-dc">dc</primary>
          </indexterm>
        </listitem>
      </varlistentry>

    </variablelist>

  </sect2>

</sect1>
